#include <iostream>

using namespace std;


void reverseArray(int arr[], int arrSize);

void removeOdd(int arr[], int &arrSize);

void splitParity(int arr[], int arrSize);

void printArray(int arr[], int arrSize);

int main() {
    int arr1[10] = {9, 2, 14, 12, -3};
    int arr1Size = 5;
    int arr2[10] = {21, 12, 6, 7, 14};
    int arr2Size = 5;
    int arr3[10] = {3, 6, 4, 1, 12};
    int arr3Size = 5;
    reverseArray(arr1, arr1Size);
    printArray(arr1, arr1Size);

    removeOdd(arr2, arr2Size);
    printArray(arr2, arr2Size);

    splitParity(arr3, arr3Size);
    printArray(arr3, arr3Size);
    return 0;
}

void printArray(int arr[], int arrSize) {
    int i;
    for (i = 0; i < arrSize; i++) {
        cout << arr[i] << ' ';
    }
    cout << endl;
}

void swapNumbers(int &num1, int &num2) {
    int temp = num1;
    num1 = num2;
    num2 = temp;
}

void reverseArray(int arr[], int arrSize) {
    int left = 0, right = arrSize - 1;
    while (left < right) {
        swapNumbers(arr[left], arr[right]);
        ++left;
        --right;
    }
}

void removeOdd(int arr[], int &arrSize) {
    int cnt_even = 0;
    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] % 2 == 0) {
            arr[cnt_even] = arr[i];
            ++cnt_even;
        }
    }
    arrSize = cnt_even;
}

void splitParity(int arr[], int arrSize) {
    int cnt_odd = 0;
    for (int i = 0; i < arrSize; ++i) {
        if (arr[i] % 2 == 1) {
            swapNumbers(arr[cnt_odd], arr[i]);
            ++cnt_odd;
        }
    }
}